--   Tables.MTL   INCLUDE ("IncomeCodes.inc")

SQLSCRIPT IncomeCodesRefresh;MSSQL; 

declare @ed datetime set @ed=convert(datetime,'1899.12.30',102)
declare @now datetime set @now=getdate()
declare @since datetime set @since=convert(datetime,'2016.01.01',102)
declare @until datetime set @until=@since-1

declare @in table (c smallint,p tinyint,s tinyint,n nvarchar(256))

insert @in (c,p,s,n) 
          select 1010, 0,0,N''
union all select 1011, 0,1,N' (       ,   01.01.2007,    ,      ,    ),  ,   '
union all select 1110, 9,1,N'     ,   01.01.2007'
union all select 1120, 9,1,N'     ,      ,     01.01.2007'
union all select 1200, 0,0,N',         '
union all select 1201, 0,0,N',             - '
union all select 1202, 0,1,N',   . , .   .. ( . ...-)  .,     .. ,   . .( ....)'
union all select 1203, 0,1,N', .  .. ....- (....   .   () ... ..)'
union all select 1211, 0,0,N', .   .   .,      .   .   . ..,  .   .,    .'
union all select 1212, 0,1,N'   .() ,. ..( ....-),      .-  ..   . '
union all select 1213, 0,1,N'    ()      ,        ,     '
union all select 1214, 0,1,N'      ()      ,        ,     '
union all select 1220, 0,1,N'    ()      (),           ,     '
union all select 1230, 0,1,N'    ()      (),        ,     '
union all select 1240, 0,1,N' , . ...., ..     ..,   ,. ...., ..   ..   .'
union all select 1300, 0,1,N',           '
union all select 1301, 0,1,N',        '
union all select 1400, 0,1,N',          (            ,  )'
union all select 1510, 0,1,N',     , , ,    , ,          '
union all select 1520, 0,1,N',     (  , , ,    , ,  ,       ,  )'
union all select 1530, 0,1,N',    -  ,      '
union all select 1531, 0,1,N',    -  ,       '
union all select 1532, 0,1,N'  . . ..,    .     . ..,     ...,    . ..  .'
union all select 1533, 0,1,N'      ,     '
union all select 1536, 0,1,N',     -  ,       ,       ,     '
union all select 1540, 0,1,N',         '
union all select 1550, 0,1,N',             (       ,    )'
union all select 2000, 0,0,N',    .    ;  .  .   .   . (    .-. )'
union all select 2001, 0,0,N'     ,      (     )'
union all select 2010, 0,0,N'   -  (   )'
union all select 2012, 0,0,N'  '
union all select 2201, 0,0,N'  ()    ,     , ,   '
union all select 2202, 0,0,N'  ()   - ,   ,    '
union all select 2203, 0,0,N'..(.)  ..,   , .-  .,  , -     , .  '
union all select 2204, 0,0,N'  ()     (-,-  )'
union all select 2205, 0,0,N' .(.)  . : .-. (, , .), .,., ,. ., .  -, -    ..'
union all select 2206, 0,0,N'  ()     ,      '
union all select 2207, 0,0,N'  ()      '
union all select 2208, 0,0,N'  ()      '
union all select 2209, 0,0,N'   , ,  '
union all select 2210, 0,1,N',   ()   , , ,   ,    '
union all select 2220, 0,0,N'      ,    '
union all select 2300, 0,0,N'   '
union all select 2400, 0,1,N'.,. .    ..., .., ., .  ...,   ,         ..  .(.);., .  .,, '
union all select 2510, 0,0,N'(  )   . ..(, )  ,     , , ,    '
union all select 2520, 0,0,N' , , ,        '
union all select 2530, 0,0,N'    '
union all select 2610,35,0,N'.,. . . ..(.), . . .., ..,.   . ..(.)   . .  .,.,.   '
union all select 2620, 0,0,N' ,          ()            , ,   ()  '
union all select 2630, 0,0,N'.,     (,)    -   ., .  .,      '
union all select 2640, 0,1,N' ,        '
union all select 2710, 0,0,N'.( ...,.  .,   .,    . . .  ., ..,   ..  ...,.  .'
union all select 2720, 0,0,N' '
union all select 2730, 0,0,N'     .,.   ,       , .() .     .'
union all select 2740,35,0,N'   ,    ,        ,   '
union all select 2750, 0,0,N'   . ., .   .,        , .(.) .   .     (  )'
union all select 2760, 0,0,N' ,    ,     ,            '
union all select 2761, 0,0,N' ,      '
union all select 2762, 0,0,N'   ,    (, , )   ( ())  (   2008 )'
union all select 2770, 0,0,N' ()   ,  ,   ,    (  ),       ( ) ,    '
union all select 2780, 0,0,N' ()    ( ) ,    ,   ,     . 28 . 217   '
union all select 2790, 0,0,N'  ( . .),    , . ,  ,       , ,   ,      . ,   '
union all select 2800, 0,1,N' (),        '
union all select 2900, 0,1,N',      '
union all select 3010,35,1,N'   ,      '
union all select 3020,35,1,N'   ,     '
union all select 3021, 0,1,N'   ,       ,         ( ,   01.01.2008)'
union all select 4800, 0,0,N' '
union all select 2002, 0,0,N' ,        ,    ,     ,       '
union all select 2003, 0,0,N' ,      ,      '
update @in set p=13 where p=0 --    13%

update N set N.=I.n, N.=I.p, N.=I.s, N.UpdateTime=@now
  from $$$$ N, @in I
 where N.=I.c 

declare @Uin table (u tinyint identity(1,1), c smallint)
insert @Uin (c) select c from @in where c not in (select  from $$$$)

insert $$$$ (UKEY,CreateTime,UpdateTime,,,,,,,,)
select ISNULL((select MAX(UKEY) from $$$$),0)+u, @now, @now, I.c, n, p, 0, 0 , 
       ISNULL((select top 1 UKEY from  $$$$ 
                where _=0 and YEAR(@since)>= and (=0 or >=YEAR(@now)) and abs(I.p-)<0.1
                order by  desc),0), @ed,@ed
  from @Uin U,@in I where U.c=I.c

update $$$$ set =1,UpdateTime=@now where  not in (select c from @in)
ENDSQLSCRIPT;